package cn.ibizlab.businesscentral.core.odoo_crm.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.odoo_crm.domain.Crm_stage;
import cn.ibizlab.businesscentral.core.odoo_crm.filter.Crm_stageSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Crm_stage] 服务对象接口
 */
public interface ICrm_stageService extends IService<Crm_stage>{

    boolean create(Crm_stage et) ;
    void createBatch(List<Crm_stage> list) ;
    boolean update(Crm_stage et) ;
    void updateBatch(List<Crm_stage> list) ;
    boolean remove(Long key) ;
    void removeBatch(Collection<Long> idList) ;
    Crm_stage get(Long key) ;
    Crm_stage getDraft(Crm_stage et) ;
    boolean checkKey(Crm_stage et) ;
    boolean save(Crm_stage et) ;
    void saveBatch(List<Crm_stage> list) ;
    Page<Crm_stage> searchDefault(Crm_stageSearchContext context) ;
    List<Crm_stage> selectByTeamId(Long id);
    void resetByTeamId(Long id);
    void resetByTeamId(Collection<Long> ids);
    void removeByTeamId(Long id);
    List<Crm_stage> selectByCreateUid(Long id);
    void removeByCreateUid(Long id);
    List<Crm_stage> selectByWriteUid(Long id);
    void removeByWriteUid(Long id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Crm_stage> getCrmStageByIds(List<Long> ids) ;
    List<Crm_stage> getCrmStageByEntities(List<Crm_stage> entities) ;
}


